package com.sky.tvheadend_manager;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.google.gson.internal.LinkedTreeMap;
import com.sky.tvheadend_manager.Muxes.Service;

public class CmdParser {
	public static  void parseCmds(String cmds){
		if(cmds==null){
			System.out.println("NULL parameter");
		}
		String[] cmds_arr = cmds.trim().split(" ");
		if(cmds_arr.length >0){
			switch(cmds_arr[0]){
			case "list": if(cmds_arr.length>1){
				getListcmd(cmds_arr);
			
			}else{
				System.out.println("missing parameter");
			}
			break;
			case "add": if(cmds_arr.length>1){
				create(cmds_arr);
			
			}else{
				System.out.println("missing create parameter");
			}
			
			break;
			case "del": if(cmds_arr.length>1){
				delete(cmds_arr);
			
			}else{
				System.out.println("missing create parameter");
			}
			break;
			case "check":
				check(cmds_arr);break;
			case "quit":System.exit(0);
				default: System.out.println("unknow command");break;
			}
		}
	}
	
	private static void create(String[] params){
		
		String str = params[1].trim();

		switch(str){
		case "tag":
			if(params.length>2){
				ChannelsManager.createTag(params[2]);
			}else{
				System.out.println("missing tag name");
				break;
			}
			break;
		case "channel": 
			if(params.length>4){
				ChannelsManager.addChannel(params[2],params[3],params[4]);
		}else{
			ChannelsManager.addChannel(params[2],params[3],null);
		}
			break;
		default:System.out.println("unknow parameter create");break;
		}
	}
	
	private static void check(String[] params){
		if(params.length<2){
			ChannelsManager.checkConfig(null,false);
			return;
		}
		String str = params[1].trim();

		switch(str){
		case ChannelsManager.CHECK_FIX:ChannelsManager.checkConfig(null,true);break;
		case ChannelsManager.CHECK_CHANNEL: 
			switch(params.length){
			case 2:
				ChannelsManager.checkConfig(params[1],false);break;
			case 3 :
				if(params[2].trim().equals(ChannelsManager.CHECK_FIX)){
					ChannelsManager.checkConfig(params[1],true);
				}else{
					ChannelsManager.checkConfig(params[1],false);
				}
			default:ChannelsManager.checkConfig(null,false);break;
			}

			break;
		default:System.out.println("unknow parameter create");break;
		}
	}
	
	private static void delete(String[] params){
		String str = params[1].trim();

		switch(str){
		case ChannelsManager.DEL_MODE_TAG: 
			if(params.length>2){
				ChannelsManager.delete(params[1],params[2],null);
			}else{
				System.out.println("missing tag name");
			}
			break;
		case ChannelsManager.DEL_MODE_SERVICE:
			if(params.length>3){
				ChannelsManager.delete(params[1],params[2],params[3]);
			}else{
				System.out.println("missing tag name");
			}
			break;
			default:System.out.println("unknow parameter delete");break;
		}
	}
	private static void getListcmd(String[] params){
	
		String str = params[1].trim();
		TvheadendInfos infos = TvheadendInfos.getInstance();
		switch(str){
		case "tags":
				infos.displayTagList();
		break;
		case "ch_config":
			switch(params.length){
			case 3:
				infos.displayChConfigList(params[2],null);
				return;
			case 4: infos.displayChConfigList(params[2], params[3]);return;
			}
			infos.displayChConfigList(null,null);
			break;
		case "ch_tag":
			if(params.length<3){
				System.out.println("missing network selection");
				break;
			}
			infos.displayChTagList(params[2]);
			break;
		case "muxes":
			if(params.length<3){
				System.out.println("missing network selection");
				break;
			}
			infos.displayMuxesList(params[2]);
		case "networks":
			infos.displayNetworksList();break;
		default:System.out.println("unknow parameter list");break;
		}

	}
	

	

}
