package com.sky.tvheadend_manager;

import java.util.ArrayList;


public class Muxes {

	Config config;
	public Config getConfig() {
		return config;
	}

	  public class Config{
		String delsys;
		int frequency;
		int symbolrate;
		String constellation;
		String fec;
		int enabled;
		int epg;
		int onid;
		int tsid;
		int scan_result;
		boolean tsid_zero;
		int pmt_06_ac3;
		boolean eit_tsid_nocheck;
		Service service;
		public int getFrequency() {
			return frequency;
		}
		public String getDelSys() {
			return delsys;
		}
		public Service getService(){
			return service;
		}
	}


	public class Service{
		
		 ArrayList<ServiceInfo> serviceInfo = new ArrayList<>() ;
		 public ArrayList<ServiceInfo> getServiceInfo(){
			 return serviceInfo;
		 }
		 
	}

	 public  class ServiceInfo{
		
		int sid;
		int lcn;
		int lcn_minor;
		int lcn2;
		int srcid;
		String svcname;
		String provider;
		int dvb_servicetype;
		boolean dvb_ignore_eit;
		int prefcapid;
		int prefcapid_lock;
		int force_caid;
		long created;
		long last_seen;
		boolean enabled;
		int auto;
		int priority;
		int s_type_user;
		int pcr;
		int pmt;
		ArrayList<Stream> stream = new ArrayList<>();
		 String serviceUUID;
		 public String getSvcname() {
				return svcname;
			}
		 public String getServiceUUID() {
				return serviceUUID;
			}
		 public String toString(){
			 return svcname+" ["+serviceUUID+"] ";
		 }
	}

	 class Stream{
		int pid;
		String type;
		int position;
		String language;
		int audio_type;
		int compositionid;
		int	ancillartyid;
		ArrayList<CAID> caidlist = new ArrayList<>();
		int parentpid;
		int width;
		int height;
		int duration;
	}

	 class CAID {
		int caid;
		int	providerid;
	}
	
	
	//transient String muxUUID; 
	String muxUUID; //DEBUG
	
	public Service newService(){
		return new Service();
	}
	public ServiceInfo newServiceInfo(){
		return new ServiceInfo();
	}
}
