package com.sky.tvheadend_manager;

import java.util.ArrayList;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.sky.tvheadend_manager.Muxes.ServiceInfo;

public class TvheadendFormatter {

	public static String serviceInfoToJson(ServiceInfo serv){
		Gson gson = new GsonBuilder().setPrettyPrinting().create();
		String json = gson.toJson(serv);
		TvheadendInfos infos = TvheadendInfos.getInstance();
		String json_muxes = gson.toJson(infos.getMux(serv.serviceUUID));
		ChannelConfig ch_config=infos.findChannel(serv.serviceUUID);
		if(ch_config!=null){
			String json_ch =gson.toJson(ch_config);
			ArrayList<Tag> tags = new ArrayList<>();
			for(String tagUUID:ch_config.tags){
				tags.add(infos.getTag(tagUUID));
			}
			String json_tags = gson.toJson(tags);
			return new StringBuilder().append(json)
					.append(json_muxes)
					.append(json_ch)
					.append(json_tags)
					.toString();
		}

		return new StringBuilder().append(json)
				.append(json_muxes)
				.toString();

	}
	
}
