package com.sky.tvheadend_manager;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.Charset;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;

public class Utils {
	/*static {
		System.loadLibrary("tvheadenparser");
	}
	*/
	private static native String processfile(String file);
	
	public static File getFile(File parent_folder,String[] subfolder){
		String[] files = parent_folder.list();
		File ret = parent_folder;
		boolean find = false;
		if(files!=null){
			for(String sub:subfolder){
				if(find){
					if(ret.isDirectory()){
						files = ret.list();
					}else{
						return null;
					}
					find=false;
				}
				for(String file_parent:files){
					if(file_parent.equals(sub)){
						ret = new File(ret.toString()+"/"+sub);
						find=true;
						break;
					}
					
			}
				if(!find){
					return null;
				}
			}
		}
		if(parent_folder.equals(ret)){
			return null;
		}
		return ret;
	}
	
	public static  <T> T parseJson(File file,Class<T> toClass,boolean compressFile){
	
		try {
			BufferedReader br;
			if(compressFile){
				String json = processfile(file.getAbsolutePath()); 
				JsonObject jObj= new JsonParser().parse(json).getAsJsonObject();
				return new Gson().fromJson(jObj, toClass);
			}else{
				StringBuilder text = new StringBuilder();

			 br = new BufferedReader(new FileReader(file));
			 String line;

				while ((line = br.readLine()) != null) {
					text.append(line);
					text.append('\n');
				}
				br.close();

				JsonObject jObj= new JsonParser().parse(text.toString()).getAsJsonObject();
				return new Gson().fromJson(jObj, toClass);
			}
			
			
		}catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static boolean writeJsonToFile(String json,String filename){
		try {
			File f = new File(filename);
			if(f.createNewFile()){
				FileOutputStream output  = new FileOutputStream(f);
				output.write(json.getBytes(Charset.forName("UTF-8")));
				output.close();
				return true;
			}else{
				if(f.delete()){
					if(f.createNewFile()){
						FileOutputStream output  = new FileOutputStream(f);
						output.write(json.getBytes(Charset.forName("UTF-8")));
						output.close();
						return true; 
					}
				}
				System.out.println("Failed to create "+filename);
				
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
	}
}
