package com.sky.tvheadend_manager;


import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.OkHttpClient.Builder;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.CookieManager;
import java.net.CookiePolicy;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.security.KeyManagementException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.UnrecoverableKeyException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.TimeUnit;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.KeyManager;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.TrustManagerFactory;
import javax.net.ssl.X509TrustManager;


//import java.net.HttpURLConnection;
//import java.net.URL;
//import 	javax.net.ssl.HttpsURLConnection;

//import org.apache.http.conn.ssl.SSLSocketFactory;

public class WebServ {

	public final static String POST = "POST";
	public final static String GET = "GET";

	/**
	 * Send request to a server
	 * 
	 * @param path
	 *            the url link
	 * @param method
	 *            POST or GET
	 * @param request
	 *            Request to send
	 * @return response from server as inputstream
	 */
	// TODO lancer en asynctask
	static public String getResponse(String path, String method, String request, InputStream certifInputStream,
			String certifPasswd,InputStream caInput) {

		try {

			final okhttp3.MediaType MEDIA_TYPE_TEXT = MediaType.parse("text/plain; charset=UTF-8");
			OkHttpClient client = new OkHttpClient();
			Builder builder = client.newBuilder().connectTimeout(30, TimeUnit.SECONDS) // connect timeout
						.readTimeout(30, TimeUnit.SECONDS) ;// socket timeout

		
			 
			try {

					SSLContext sslContext = null;
					if (certifInputStream != null) {
						CertificateFactory cf = CertificateFactory.getInstance("X.509");
// From https://www.washington.edu/itconnect/security/ca/load-der.crt
						//InputStream caInput = new BufferedInputStream(new FileInputStream("load-der.crt"));
						Certificate ca;
						try {
							ca = cf.generateCertificate(caInput);
							System.out.println("ca=" + ((X509Certificate) ca).getSubjectDN());
						} finally {
							caInput.close();
						}

// Create a KeyStore containing our trusted CAs
						String keyStoreType = KeyStore.getDefaultType();
						KeyStore keyStore = KeyStore.getInstance(keyStoreType);
						keyStore.load(null, null);
						keyStore.setCertificateEntry("ca", ca);

// Create a TrustManager that trusts the CAs in our KeyStore
						String tmfAlgorithm = TrustManagerFactory.getDefaultAlgorithm();
						TrustManagerFactory tmf = TrustManagerFactory.getInstance(tmfAlgorithm);
						tmf.init(keyStore);

					KeyStore clientStore = KeyStore.getInstance("PKCS12");

					clientStore.load(certifInputStream, certifPasswd.toCharArray());

					KeyManagerFactory kmf = KeyManagerFactory.getInstance("X509");
					kmf.init(clientStore, certifPasswd.toCharArray());
					KeyManager[] kms = kmf.getKeyManagers();


					TrustManager[] tms = tmf.getTrustManagers();

					sslContext = SSLContext.getInstance("TLS");
				
						sslContext.init(kms, tms, new SecureRandom());
					

					X509TrustManager x509Tm = null;
					for (TrustManager tm : tmf.getTrustManagers()) {
						if (tm instanceof X509TrustManager) {
							x509Tm = (X509TrustManager) tm;
							break;
						}
					}
					
					
					builder.sslSocketFactory(sslContext.getSocketFactory(), x509Tm);
				}
			} catch (NoSuchAlgorithmException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CertificateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}catch (KeyManagementException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (KeyStoreException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (UnrecoverableKeyException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			
			Request req = null;
			if (method.equals(GET)) {
				req = new Request.Builder()
						.url(path)
						.build();
			} else {
				req = new Request.Builder()
						.url(path)
						.post(RequestBody.create(MEDIA_TYPE_TEXT, URLEncoder.encode(request,"UTF-8")))
						.build();
			}
			Response response = client.newCall(req).execute();
			if (!response.isSuccessful()) {
				throw new IOException("Unexpected code " + response);
			}
			String ret = response.body().string();
			response.body().close();
		
			return ret;

		} catch (

		IOException e) {
			e.printStackTrace();

		}

		return null;
	}

	static public String getResponseUrlConnection(String path, String method, String request, InputStream certifInputStream,
												  String certifPasswd, InputStream caInput) {
		try {
			SSLContext sslContext = null;
			if (certifInputStream != null) {
				CertificateFactory cf = CertificateFactory.getInstance("X.509");
// From https://www.washington.edu/itconnect/security/ca/load-der.crt
				//InputStream caInput = new BufferedInputStream(new FileInputStream("load-der.crt"));
				Certificate ca;

					ca = cf.generateCertificate(caInput);
					System.out.println("ca=" + ((X509Certificate) ca).getSubjectDN());


// Create a KeyStore containing our trusted CAs
				String keyStoreType = KeyStore.getDefaultType();
				KeyStore keyStore = KeyStore.getInstance(keyStoreType);
				keyStore.load(null, null);
				keyStore.setCertificateEntry("ca", ca);

// Create a TrustManager that trusts the CAs in our KeyStore
				String tmfAlgorithm = TrustManagerFactory.getDefaultAlgorithm();
				TrustManagerFactory tmf = TrustManagerFactory.getInstance(tmfAlgorithm);
				tmf.init(keyStore);

				KeyStore clientStore = KeyStore.getInstance("PKCS12");

				clientStore.load(certifInputStream, certifPasswd.toCharArray());

				KeyManagerFactory kmf = KeyManagerFactory.getInstance("X509");
				kmf.init(clientStore, certifPasswd.toCharArray());
				KeyManager[] kms = kmf.getKeyManagers();

				/*FileInputStream myKeys = new FileInputStream("/usr/lib/jvm/java-8-oracle/jre/lib/security/cacerts");
				KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
				trustStore.load(myKeys, "changeit".toCharArray());*/

				/*TrustManagerFactory tmf = TrustManagerFactory
						.getInstance(TrustManagerFactory.getDefaultAlgorithm());
				tmf.init(clientStore);*/
				TrustManager[] tms = tmf.getTrustManagers();

				sslContext = SSLContext.getInstance("TLS");
			
					sslContext.init(kms, tms, new SecureRandom());
				

				X509TrustManager x509Tm = null;
				for (TrustManager tm : tmf.getTrustManagers()) {
					if (tm instanceof X509TrustManager) {
						x509Tm = (X509TrustManager) tm;
						break;
					}
				}
			
			}
			URL url = new URL(path);
			HttpURLConnection connection = (HttpURLConnection) url.openConnection();
			if (connection instanceof HttpsURLConnection) {
				if(sslContext!=null)
			    ((HttpsURLConnection)connection)
			         .setSSLSocketFactory(sslContext.getSocketFactory());
			}
			if(method.equals(POST)){
			connection.setDoOutput(true);
		    

		    OutputStreamWriter writer = new OutputStreamWriter(connection.getOutputStream());

		    writer.write(request);
		    writer.flush();
			}else{
				int responseCode = connection.getResponseCode();
			}
			//connection.setRequestMethod(method);
			//connection.connect();
			BufferedReader b = new BufferedReader(new InputStreamReader(connection.getInputStream()));
			String line = "";
			StringBuilder resp = new StringBuilder();
			while ((line = b.readLine()) != null) {
			  resp.append(line);
			}
			b.close();
			return resp.toString();
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (CertificateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (KeyManagementException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (KeyStoreException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnrecoverableKeyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return null;
	}
	static public InputStream getResponse2(String path, String method, String request) {

		try {

			final MediaType MEDIA_TYPE_TEXT = MediaType.parse("application/json; charset=UTF-8");
			OkHttpClient client = new OkHttpClient();
			Builder builder = client.newBuilder();
			builder.connectTimeout(30, TimeUnit.SECONDS); // connect timeout
			builder.readTimeout(30, TimeUnit.SECONDS); // socket timeout
			client = builder.build();

			Request req = null;
			if (method.equals(GET)) {
				req = new Request.Builder().url(path).build();
			} else {
				req = new Request.Builder().url(path).post(RequestBody.create(MEDIA_TYPE_TEXT, request)).build();
			}
			Response response = client.newCall(req).execute();
			if (!response.isSuccessful()) {
				throw new IOException("Unexpected code " + response);
			}

			return response.body().byteStream();

		} catch (IOException e) {

		}

		return null;
	}
}
