package com.sky.tvheadend_manager.ui;

import java.util.ArrayList;

import org.controlsfx.control.ListSelectionView;

import com.sky.tvheadend_manager.Tag;
import com.sky.tvheadend_manager.TvheadendInfos;
import com.sky.tvheadend_manager.Utils;
import com.google.gson.Gson;
import com.sky.tvheadend_manager.ChannelConfig;
import com.sky.tvheadend_manager.ChannelsManager;
import com.sky.tvheadend_manager.Muxes.ServiceInfo;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

public class EditChannelController {
	@FXML 
	private ListSelectionView<String> tagSelected;
	@FXML
	private TextField numberChannel;
	@FXML
	private Button save;
	@FXML
	private TextField nameChannel;
	
	private ArrayList<ChannelConfig> chConfigs;
	private MainApp mainApp;
	@FXML
	private void initialize(){

		TvheadendInfos infos = TvheadendInfos.getInstance();//TODO s'assurer que infos populate
		ObservableList<String> tagsObs = FXCollections.observableArrayList();
		for(Tag tag:infos.getTagList().values()){
			tagsObs.add(tag.getName());
		}


		tagSelected.getSourceItems().addAll(tagsObs);

		save.setOnAction(event->{
			int number = Integer.parseInt(numberChannel.getText());
			if(chConfigs.size()==1){
				ChannelConfig ch_conf = chConfigs.get(0);
				ch_conf.setNumber(number);
				
				ArrayList<String> chTag = ch_conf.getTags();
				chTag.clear();
				for(String str:tagSelected.getTargetItems()){
					Tag tag=infos.getTagByName(str);
					if(tag!=null){
						chTag.add(tag.getTagUUID());
					}
				}
				ChannelsManager.addChannel(ch_conf);
			}else{
				for(ChannelConfig ch_conf:chConfigs){
					ch_conf.setNumber(number);

					ChannelsManager.addChannel(ch_conf);
				}
			}
			Stage stage = (Stage) save.getScene().getWindow();
			
			stage.close();
		});

	}
	
	public void setMainApp(MainApp mainApp){
		this.mainApp = mainApp;
	}
	
	public void setChannelConfig(ArrayList<ChannelConfig> channelConfigs){
		chConfigs = channelConfigs;
		if(chConfigs.size()==1){
			ChannelConfig ch_conf = channelConfigs.get(0);
		numberChannel.setText(String.valueOf(ch_conf.getNumber()));
		TvheadendInfos infos = TvheadendInfos.getInstance();
		String servUUID =ch_conf.getServices().get(0);
		ServiceInfo serv=infos.findServiceInfos(servUUID);
		if(serv!=null){
			nameChannel.setText(serv.getSvcname());
		}
		for(String tagUUID:ch_conf.getTags()){
			Tag tag=infos.getTag(tagUUID);
			if(tag!=null){
				String tagName = infos.findTagName(tag.getTagUUID());
				tagSelected.getSourceItems().remove(tagName);
				tagSelected.getTargetItems().add(tagName);
	    		}
		}
		}else{
			numberChannel.setPromptText("multiple");
			nameChannel.setPromptText("multiples");
			tagSelected.setVisible(false);
			tagSelected.setManaged(false);;
		}
	}

}
