package com.sky.tvheadend_manager.ui;

import com.sky.tvheadend_manager.ChannelsManager;
import com.sky.tvheadend_manager.Tag;
import com.sky.tvheadend_manager.TvheadendInfos;

import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

public class EditTagDialogController {

	@FXML
	CheckBox enabled;
	@FXML
	TextField index;
	@FXML
	TextField name;
	@FXML
	CheckBox internal;
	@FXML
	CheckBox private_bool;
	@FXML
	TextField icon;
	@FXML
	CheckBox title_icon;
	@FXML
	TextField comment;
	
	Stage dialogStage;
	@FXML
	private void initialize(){
		
	}
	
	public void setDialogStage(Stage dialogStage) {
        this.dialogStage = dialogStage;
    }
	
	public void setTag(Tag tag){
		if(tag!=null){
			enabled.setSelected(tag.isEnabled());
			index.setText(String.valueOf(tag.getIndex()));
			name.setText(tag.getName());
			internal.setSelected(tag.isInternal());
			private_bool.setSelected(tag.isPrivate_bool());
			icon.setText(tag.getIcon());
			title_icon.setSelected(tag.isTitle_icon());
			comment.setText(tag.getComment());
			
			
		}
	}
	
	@FXML
	public void saveClicked(){
		if(name.getText()!=null && name.getText().length()>0){
			ChannelsManager.createTag(name.getText());
			dialogStage.close();
		}else{
			Alert alert = new Alert(AlertType.ERROR);
            alert.initOwner(dialogStage);
            alert.setTitle("Invalid Fields");
            alert.setHeaderText("Please correct invalid fields");
            alert.setContentText("Name invalid");

            alert.showAndWait();
		}
		
	}
}
