package com.sky.tvheadend_manager.ui;

import java.io.File;

import com.google.gson.Gson;
import com.sky.tvheadend_manager.Settings;
import com.sky.tvheadend_manager.Tag;
import com.sky.tvheadend_manager.TvheadendInfos;
import com.sky.tvheadend_manager.Utils;

import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.stage.DirectoryChooser;
import javafx.stage.FileChooser;
import javafx.stage.Stage;

public class PreferenceDialogController {
	@FXML
	private TextField folder_tv;
	@FXML
	private Button button_Choose;
	@FXML
	private TextField server_address;
	@FXML
	private Button button_valide;
	
	private MainApp mainApp;
	private Stage dialogStage;
	
	public void setMainApp(MainApp mainApp){
		this.mainApp = mainApp;
	}
	
	@FXML
	private void initialize(){
		button_Choose.setOnAction(event->{
			DirectoryChooser dirChooser = new DirectoryChooser();
			dirChooser.setTitle("Open Resource Folder");
			File file = dirChooser.showDialog(mainApp.primaryStage);
			if(file!=null){
	
				folder_tv.setText(file.getAbsolutePath());
			
			}
		});
		
		button_valide.setOnAction(event->{
			TvheadendInfos infos = TvheadendInfos.getInstance();
			Settings settings = new Settings();
			settings.setFolder(folder_tv.getText());
			settings.setServer(server_address.getText());
			Utils.writeJsonToFile(new Gson().toJson(settings), Settings.SETTING_NAME);
			infos.setTvheadendServer(server_address.getText());
			infos.setTvheadendFolder(folder_tv.getText());
			dialogStage.close();
			
		});
	}
	
	public void setInfos(){
		TvheadendInfos infos = TvheadendInfos.getInstance();
		  folder_tv.setText(infos.getTvheadendFoler());
		  server_address.setText(infos.getTvheadendServer());
	}

	public void setDialogStage(Stage dialogStage) {
        this.dialogStage = dialogStage;
    }
}
