package com.sky.tvheadend_manager.ui;

import java.io.IOException;
import java.util.Optional;

import com.sky.tvheadend_manager.ChannelsManager;
import com.sky.tvheadend_manager.TvheadendFormatter;
import com.sky.tvheadend_manager.TvheadendInfos;
import com.sky.tvheadend_manager.Muxes.ServiceInfo;

import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonType;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Priority;
import javafx.stage.Modality;
import javafx.stage.Stage;

public class RootLayoutController {

	MainApp mainApp;
	
	public void setMainApp(MainApp mainApp){
		this.mainApp =mainApp;
	}
	@FXML
	private void initialize(){
		
	}
	
	@FXML
	private void refresh(){
		TvheadendInfos infos = TvheadendInfos.getInstance();
		infos.populateInfo();
	}
	
	@FXML
	private void displayPreference(){
		mainApp.showPreferenceDialog();
	}
	
	@FXML
	private void fixConfError(){
		String error = ChannelsManager.checkConfig(ChannelsManager.CHECK_CHANNEL, false);
		Alert alert = new Alert(AlertType.CONFIRMATION);
		alert.setTitle("Fix error");
		TextArea textArea = new TextArea(error);
		textArea.setEditable(false);
		textArea.setWrapText(true);

		textArea.setMaxWidth(Double.MAX_VALUE);
		textArea.setMaxHeight(Double.MAX_VALUE);
		GridPane.setVgrow(textArea, Priority.ALWAYS);
		GridPane.setHgrow(textArea, Priority.ALWAYS);

		GridPane expContent = new GridPane();
		expContent.setMaxWidth(Double.MAX_VALUE);
		//expContent.add(label, 0, 0);
		expContent.add(textArea, 0, 1);

		// Set expandable Exception into the dialog pane.
		alert.getDialogPane().setExpandableContent(expContent);
		Optional<ButtonType> result = alert.showAndWait();
		if(result.get() == ButtonType.OK){
			ChannelsManager.checkConfig(ChannelsManager.CHECK_CHANNEL, true);
		}
	}
	
	
}
