package com.sky.tvheadend_manager;

import static org.junit.Assert.*;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;

import org.junit.Test;

import com.sky.tvheadend_manager.Muxes.ServiceInfo;

public class TvheadManagerTest2 {
	static final String folder = "files/tvheadend_test";
	@Test public void testCreateTag() {
		String out_console_file="output_console";
		PrintStream out;
	
			String tagName = "Unitest_TNT";
			/*UtilsUnitTest.clearConsoleFile(out_console_file);
			out = new PrintStream(out_console_file);

			System.setOut(out);*/
			TvheadendInfos infos = TvheadendInfos.getInstance();
			infos.setTvheadendFolder(folder);
			UtilsUnitTest.waitPopulate();
			CmdParser.parseCmds("del tag "+tagName);
			infos.populateInfo();
			UtilsUnitTest.waitPopulate();
			assertTrue("Tag TNT not delete ",!tagExistUnique(tagName));
			CmdParser.parseCmds( "add tag "+tagName);
			assertTrue("Tag TNT not add",tagExistUnique(tagName));
			infos.populateInfo();
			UtilsUnitTest.waitPopulate();
			assertTrue("Tag TNT not add",tagExistUnique(tagName));

			CmdParser.parseCmds("add tag TNT ");
			assertTrue("Tag TNT multiple add",tagExistUnique(tagName));
			infos.populateInfo();
			UtilsUnitTest.waitPopulate();
			assertTrue("Tag TNT multiple add",tagExistUnique(tagName));


		
	}

	@Test
	public void testDeleteService(){
		String tagName = "Unitest_Clair";
		TvheadendInfos infos = TvheadendInfos.getInstance();
		infos.setTvheadendFolder(folder);
		UtilsUnitTest.waitPopulate();
		CmdParser.parseCmds("add channel tst "+tagName+" clair ");
		ServiceInfo srv = new Muxes().newServiceInfo();
		srv.svcname = "TF1";
		srv.sid = 1145;
		srv.serviceUUID = "e8949898269dd03083d3198176284e5b";
		assertTrue("Channel TF1 missing",tagContainService(tagName, srv));
		ChannelsManager.delete(ChannelsManager.DEL_MODE_SERVICE, srv.serviceUUID, tagName);
		assertTrue("Channel TF1 still exist",!tagContainService(tagName, srv));
	}
	
	@Test public void testAddUnencrypted() {
		String out_console_file="output_console";
		PrintStream out;
		
			String tagName = "Unitest_Clair";
			/*UtilsUnitTest.clearConsoleFile(out_console_file);
			out = new PrintStream(out_console_file);

			System.setOut(out);*/
			TvheadendInfos infos = TvheadendInfos.getInstance();
			UtilsUnitTest.waitPopulate();
			CmdParser.parseCmds("del tag "+tagName);
			infos.populateInfo();

			UtilsUnitTest.waitPopulate();
			assertTrue("Tag CLAIR not delete ",!tagExistUnique(tagName));
			
			CmdParser.parseCmds("add channel tst "+tagName+" clair ");

			assertTrue("Tag CLAIR not add",tagExistUnique(tagName));
			infos.populateInfo();
			UtilsUnitTest.waitPopulate();
			assertTrue("Tag CLAIR not add",tagExistUnique(tagName));

			ServiceInfo srv = new Muxes().newServiceInfo();
			srv.svcname = "TF1";
			srv.sid = 1145;
			assertTrue("Channel TF1 missing",tagContainService(tagName, srv));


		
	}

	@Test public void testAddProvId() {
		String out_console_file="output_console";
		PrintStream out;
	

			String tagName = "Unitest_BBOX";
			/*UtilsUnitTest.clearConsoleFile(out_console_file);
			out = new PrintStream(out_console_file);

			System.setOut(out);*/
			TvheadendInfos infos = TvheadendInfos.getInstance();
			infos.setTvheadendFolder(folder);
			UtilsUnitTest.waitPopulate();
			CmdParser.parseCmds("del tag "+tagName);
			infos.populateInfo();
			
			UtilsUnitTest.waitPopulate();
			assertTrue("Tag BBOX not delete ",!tagExistUnique(tagName));
	

			CmdParser.parseCmds("add channel 0xa823 "+tagName +" provid ");

			assertTrue("Tag BBOX not add",tagExistUnique(tagName));
			infos.populateInfo();
			UtilsUnitTest.waitPopulate();
			assertTrue("Tag BBOX not add",tagExistUnique(tagName));
			
			ServiceInfo srv = new Muxes().newServiceInfo();
			srv.svcname = "CINE+ CLUB";
			srv.sid = 8302;
			assertTrue("Channel CINE+ CLUB missing",tagContainService(tagName, srv));


		
	}

	private boolean tagExistUnique(String tagName){
		boolean ret = false;
		TvheadendInfos infos = TvheadendInfos.getInstance();
		for(Tag tag:infos.tagsList.values()){
			if(tag.name.equals(tagName)){
				ret^=true;
			}
		}
		return ret;
	}
	private boolean tagContainService(String tagName,ServiceInfo serv){
		TvheadendInfos infos = TvheadendInfos.getInstance();
		for(ChannelConfig ch_config:infos.getChannelsTagList(tagName)){
			for(String servUUID:ch_config.getServices()){
			ServiceInfo serv_info =infos.findServiceInfos(servUUID);
			if(serv.svcname.equals(serv_info.svcname) && serv.sid==serv_info.sid){
				return true;
			}
			}
		}
		return false;
	}
	
	
}
