package com.sky.tvheadend_manager;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class UtilsUnitTest {

	public static void clearConsoleFile(String name){
		File f = new File(name);
		if(f.exists())
			f.delete();
	}
	
	public static boolean findAllOutput(String str,File f){
		try {
			BufferedReader br = new BufferedReader(new FileReader(f));
			char[] buf = new  char[1024];
			
			while(br.read(buf)>0){
				if(new String(buf).contains(str)){
					br.close();
					return true;
				}
			}
			br.close();
		}catch(IOException e){
			e.printStackTrace();
		}
		
		return false;
	}
	public static String readLineFile(File f,int line_pos){
	
		try {
			BufferedReader br = new BufferedReader(new FileReader(f));
			String line;
			int i = 0;
			while((line =br.readLine())!=null){
				if(line_pos<++i)
					break;
			}
			br.close();
			return line;
		}catch(IOException e){
			e.printStackTrace();
		}
			return null;
			
	}
	

	
	public static String tail( File file, int lines) {
	    java.io.RandomAccessFile fileHandler = null;
	    try {
	        fileHandler = 
	            new java.io.RandomAccessFile( file, "r" );
	        long fileLength = fileHandler.length() - 1;
	        StringBuilder sb = new StringBuilder();
	        int line = 0;

	        for(long filePointer = fileLength; filePointer != -1; filePointer--){
	            fileHandler.seek( filePointer );
	            int readByte = fileHandler.readByte();

	             if( readByte == 0xA ) {
	                if (filePointer < fileLength) {
	                    line = line + 1;
	                }
	            } else if( readByte == 0xD ) {
	                if (filePointer < fileLength-1) {
	                    line = line + 1;
	                }
	            }
	            if (line >= lines) {
	                break;
	            }
	            sb.append( ( char ) readByte );
	        }

	        String lastLine = sb.reverse().toString();
	        return lastLine;
	    } catch( java.io.FileNotFoundException e ) {
	        e.printStackTrace();
	        return null;
	    } catch( java.io.IOException e ) {
	        e.printStackTrace();
	        return null;
	    }
	    finally {
	        if (fileHandler != null )
	            try {
	                fileHandler.close();
	            } catch (IOException e) {
	            }
	    }
	}
	
	public static void waitPopulate(){
		int maxT = 10000;
		int i=0;
		try {
			TvheadendInfos infos = TvheadendInfos.getInstance();
			
			while(i<maxT){
				System.out.println(infos.tagsListPopulated +","+ infos.networksListPopulated 
						+ "," +infos.mapMuxesListPopulated +","+ infos.chConfigListPopulated);
				if(infos.tagsListPopulated && infos.networksListPopulated 
						&& infos.mapMuxesListPopulated && infos.chConfigListPopulated){
					return;
				}
				Thread.sleep(500);System.out.println("waitpopulate "+i);
				i+=500;

			}
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
