/*
 * main.c
 *
 *  Created on: 25 juil. 2016
 *      Author: angelofskies
 */

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdint.h>
#include "htsmsg.h"
#include "htsbuf.h"
#include "htsmsg_binary.h"
#include "misc/dbl.h"
#include "htsmsg_json.h"

extern uint8_t *tvh_gzip_inflate ( const uint8_t *data, size_t size, size_t orig );
//extern uint8_t *tvh_gzip_deflate ( const uint8_t *data, size_t orig, size_t *size );
extern  void htsmsg_json_write(htsmsg_t *msg, htsbuf_queue_t *hq, int isarray,
		  int indent, int pretty);



int main(int argc, char **argv) {
	if(argc<2){
		exit(1);
	}
	int fd1 = open(argv[1], O_RDONLY);
	if (fd1 > 0) {
		ssize_t n, size;
		char *mem;
		htsmsg_t *r = NULL;
		off_t currentPos =lseek(fd1, (size_t)0, SEEK_CUR);
		size = lseek(fd1, (size_t)0, SEEK_END);
		lseek(fd1, currentPos, SEEK_SET);

		/* Load data */
		mem    = malloc(size+1);
		n      = read(fd1,mem,size);

		if (n >= 0) mem[n] = 0;

		/* Decode */
		if(n == size) {
			if (size > 12 && memcmp(mem, "\xff\xffGZIP00", 8) == 0) {

				uint32_t orig = ((mem[8]&0xff) << 24) | ((mem[9]&0xff) << 16) | ((mem[10]&0xff) << 8) | (mem[11]&0xff);
				if (orig > 10*1024*1024U) {
					//tvhlog(LOG_ALERT, "settings", "too big gzip for %s", filename);
					printf("too big gzip for\n");
				} else if (orig > 0) {
					uint8_t *unpacked = tvh_gzip_inflate((uint8_t *)mem + 12, size - 12, orig);
					if (unpacked) {
						r = htsmsg_binary_deserialize(unpacked, orig, NULL);

						free(unpacked);
					}
				}

			} else {
				r = htsmsg_json_deserialize(mem);
			}


			if(r != NULL){

				int pretty = 1;
				int indent = 2;

				htsbuf_queue_t hq;

				htsbuf_queue_init(&hq, 0);
				htsmsg_json_write(r, &hq, 0,indent, pretty);
				printf("%s\n",htsbuf_to_string(&hq));
				/* Close */

			}

		}
		free(mem);
		close(fd1);
	}

	exit(0);

}
