/*
 * parserlib.c
 *
 *  Created on: 7 août 2016
 *      Author: sheva
 */
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
#include <jni.h>
#include <linux/limits.h>
#include <string.h>
#include "htsmsg.h"
#include "htsbuf.h"
#include "htsmsg_binary.h"
#include "misc/dbl.h"
#include "htsmsg_json.h"

typedef struct {
    JNIEnv* env;
    jobject thiz;
    jstring file;

} infospfile;

jobject object;
JavaVM* jvm;


extern uint8_t *tvh_gzip_inflate ( const uint8_t *data, size_t size, size_t orig );
extern  void htsmsg_json_write(htsmsg_t *msg, htsbuf_queue_t *hq, int isarray,
		  int indent, int pretty);
/*void* processfile(void* infos){
	JNIEnv *env = ((infospfile*)infos)->env;
	jobject thiz = ((infospfile*)infos)->thiz;
	jstring file = ((infospfile*)infos)->file;
	const char *filename=(*env)->GetStringUTFChars(env, file, 0);
	char empty[10]="null";
	jstring ret= (*env)->NewStringUTF(env,empty); ;

	if(filename==NULL)
		return ret;
	int fd1 = open(filename, O_RDONLY);
		if (fd1 > 0) {
			ssize_t n, size;
			char *mem;
			htsmsg_t *r = NULL;
			off_t currentPos =lseek(fd1, (size_t)0, SEEK_CUR);
			size = lseek(fd1, (size_t)0, SEEK_END);
			lseek(fd1, currentPos, SEEK_SET);


			mem    = malloc(size+1);
			n      = read(fd1,mem,size);

			if (n >= 0) mem[n] = 0;

			// Decode
			if(n == size) {
				if (size > 12 && memcmp(mem, "\xff\xffGZIP00", 8) == 0) {

					uint32_t orig = ((mem[8]&0xff) << 24) | ((mem[9]&0xff) << 16) | ((mem[10]&0xff) << 8) | (mem[11]&0xff);
					if (orig > 10*1024*1024U) {
						//tvhlog(LOG_ALERT, "settings", "too big gzip for %s", filename);
						printf("too big gzip for\n");
					} else if (orig > 0) {
						uint8_t *unpacked = tvh_gzip_inflate((uint8_t *)mem + 12, size - 12, orig);
						if (unpacked) {
							r = htsmsg_binary_deserialize(unpacked, orig, NULL);

							free(unpacked);
						}
					}

				} else {
					r = htsmsg_json_deserialize(mem);
				}


				if(r != NULL){

					int pretty = 1;
					int indent = 2;

					htsbuf_queue_t hq;

					htsbuf_queue_init(&hq, 0);
					htsmsg_json_write(r, &hq, 0,indent, pretty);
					//printf("%s\n",htsbuf_to_string(&hq));

					ret= (*env)->NewStringUTF(env, htsbuf_to_string(&hq));


				}

			}
			free(mem);
			close(fd1);
		}
	(*env)->ReleaseStringUTFChars(env, file, filename);
	return &ret;


}*/
JNIEXPORT jstring JNICALL
Java_com_sky_tvheadend_1manager_Utils_processfile(JNIEnv *env, jobject instance,jstring file) {

    pthread_t th_id;
    void * status;
    infospfile* infos = malloc(sizeof(infospfile));
    infos->env = env;
    infos->thiz = instance;
    infos->file = file;
    object = (*env)->NewGlobalRef(env, instance );
    (*env)->GetJavaVM(env, &jvm );
   /* pthread_create(&th_id,
                   NULL, processfile, (void *) infos);
    //pthread_detach(th_id);
    pthread_join(th_id, &status);
    return *status;*/
    const char *filename=(*env)->GetStringUTFChars(env, file, 0);
    	char empty[10]="null";
    	jstring ret= (*env)->NewStringUTF(env,empty); ;

    	if(filename==NULL)
    		return ret;
    	int fd1 = open(filename, O_RDONLY);
    		if (fd1 > 0) {
    			ssize_t n, size;
    			char *mem;
    			htsmsg_t *r = NULL;
    			off_t currentPos =lseek(fd1, (size_t)0, SEEK_CUR);
    			size = lseek(fd1, (size_t)0, SEEK_END);
    			lseek(fd1, currentPos, SEEK_SET);

    			/* Load data */
    			mem    = malloc(size+1);
    			n      = read(fd1,mem,size);

    			if (n >= 0) mem[n] = 0;

    			/* Decode */
    			if(n == size) {
    				if (size > 12 && memcmp(mem, "\xff\xffGZIP00", 8) == 0) {

    					uint32_t orig = ((mem[8]&0xff) << 24) | ((mem[9]&0xff) << 16) | ((mem[10]&0xff) << 8) | (mem[11]&0xff);
    					if (orig > 10*1024*1024U) {
    						//tvhlog(LOG_ALERT, "settings", "too big gzip for %s", filename);
    						printf("too big gzip for\n");
    					} else if (orig > 0) {
    						uint8_t *unpacked = tvh_gzip_inflate((uint8_t *)mem + 12, size - 12, orig);
    						if (unpacked) {
    							r = htsmsg_binary_deserialize(unpacked, orig, NULL);

    							free(unpacked);
    						}
    					}

    				} else {
    					r = htsmsg_json_deserialize(mem);
    				}


    				if(r != NULL){

    					int pretty = 1;
    					int indent = 2;

    					htsbuf_queue_t hq;

    					htsbuf_queue_init(&hq, 0);
    					htsmsg_json_write(r, &hq, 0,indent, pretty);
    					//printf("%s\n",htsbuf_to_string(&hq));

    					ret= (*env)->NewStringUTF(env, htsbuf_to_string(&hq));
    					/* Close */

    				}

    			}
    			free(mem);
    			close(fd1);
    		}
    	(*env)->ReleaseStringUTFChars(env, file, filename);
    	return ret;

}
